'use strict';

var _interopRequireWildcard = function (obj) { return obj && obj.__esModule ? obj : { 'default': obj }; };

var _classCallCheck = function (instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } };

var _inherits = function (subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; };

exports.__esModule = true;

var _Atom2 = require('./base');

var _Atom3 = _interopRequireWildcard(_Atom2);

var Alternative = (function (_Atom) {
  function Alternative(atoms) {
    _classCallCheck(this, Alternative);

    _Atom.call(this);
    this._atoms = atoms;
  }

  _inherits(Alternative, _Atom);

  Alternative.prototype.run = function run(stream, index) {
    var result = undefined;

    for (var i = 0; i < this._atoms.length; i++) {
      result = this._atoms[i].run(stream, index).aggregate(result);

      if (result.status) {
        return result;
      }
    }

    return result;
  };

  return Alternative;
})(_Atom3['default']);

exports['default'] = Alternative;
module.exports = exports['default'];