'use strict';

var _interopRequireWildcard = function (obj) { return obj && obj.__esModule ? obj : { 'default': obj }; };

var _classCallCheck = function (instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } };

var _inherits = function (subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; };

exports.__esModule = true;

var _Atom2 = require('./base');

var _Atom3 = _interopRequireWildcard(_Atom2);

var _resolve$reject = require('../result');

var Custom = (function (_Atom) {
  function Custom(fn) {
    _classCallCheck(this, Custom);

    _Atom.call(this);
    this._fn = fn(_resolve$reject.resolve, _resolve$reject.reject);
  }

  _inherits(Custom, _Atom);

  Custom.prototype.run = function run(stream, index) {
    return this._fn(stream, index);
  };

  return Custom;
})(_Atom3['default']);

exports['default'] = Custom;
module.exports = exports['default'];