'use strict';

var _interopRequireWildcard = function (obj) { return obj && obj.__esModule ? obj : { 'default': obj }; };

var _classCallCheck = function (instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } };

var _inherits = function (subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; };

exports.__esModule = true;

var _Atom2 = require('./base');

var _Atom3 = _interopRequireWildcard(_Atom2);

var ExprAny = (function (_Atom) {
  function ExprAny() {
    _classCallCheck(this, ExprAny);

    if (_Atom != null) {
      _Atom.apply(this, arguments);
    }
  }

  _inherits(ExprAny, _Atom);

  ExprAny.prototype.run = function run(stream, index) {
    if (index < stream.length) {
      return this._resolve(index + 1, stream.charAt(index));
    }

    return this._reject(index, 'any');
  };

  return ExprAny;
})(_Atom3['default']);

exports['default'] = ExprAny;
module.exports = exports['default'];