'use strict';

var _interopRequireWildcard = function (obj) { return obj && obj.__esModule ? obj : { 'default': obj }; };

var _classCallCheck = function (instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } };

var _inherits = function (subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; };

exports.__esModule = true;

var _Atom2 = require('./base');

var _Atom3 = _interopRequireWildcard(_Atom2);

var Named = (function (_Atom) {
  function Named(atom, name) {
    _classCallCheck(this, Named);

    _Atom.call(this);
    this._atom = atom;
    this._name = name;
  }

  _inherits(Named, _Atom);

  Named.prototype.run = function run(stream, index) {
    var _value;

    var result = this._atom.run(stream, index);

    if (!result.status) {
      return result;
    }

    var value = (_value = {}, _value[this._name] = this._flatten(result.value, true), _value);

    return this._resolve(result.index, value).aggregate(result);
  };

  return Named;
})(_Atom3['default']);

exports['default'] = Named;
module.exports = exports['default'];