'use strict';

var _interopRequireWildcard = function (obj) { return obj && obj.__esModule ? obj : { 'default': obj }; };

var _classCallCheck = function (instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } };

var _inherits = function (subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; };

exports.__esModule = true;

var _Atom2 = require('./base');

var _Atom3 = _interopRequireWildcard(_Atom2);

var Lazy = (function (_Atom) {
  function Lazy(fn) {
    _classCallCheck(this, Lazy);

    _Atom.call(this);
    this._fn = fn;
    this._parser = null;
  }

  _inherits(Lazy, _Atom);

  Lazy.prototype.run = function run(stream, index) {
    if (this._parser === null) {
      this._parser = this._fn();
    }

    return this._parser.run(stream, index);
  };

  return Lazy;
})(_Atom3['default']);

exports['default'] = Lazy;
module.exports = exports['default'];